//***************************************
// GY-45 MMA8452 IICԳ
// ʹõƬSTC89C51 
// 11.0592M
// ʾԴ   9600
// 뻷 Keil uVision2
// ο꾧վ24c04ͨų
// ʱ䣺2011121
// QQ531389319
//****************************************
#include  <REG51.H>	
#include  <math.h>    //Keil library  
#include  <stdio.h>   //Keil library	
#include  <INTRINS.H>
#define   uchar unsigned char
#define   uint unsigned int	

sbit	  SCL=P1^0;      //IICʱŶ
sbit 	  SDA=P1^1;      //IICŶ

#define	SlaveAddress   0x38	//IICеĴӵַ,SA0ַŲͬ޸

typedef unsigned char  BYTE;
typedef unsigned short WORD;

BYTE BUF[8];                         //ݻ      	
uchar ge,shi,bai,qian,wan;           //ʾ
int  dis_data;                       //
int x,y,z;

void delay(unsigned int k);
void Init_MMA8452(void);             //ʼMMA8452
void conversion(uint temp_data);

void  Single_Write_MMA8452(uchar REG_Address,uchar REG_data);   //д
uchar Single_Read_MMA8452(uchar REG_Address);                   //ȡڲĴ
void  Multiple_Read_MMA8452();                                  //ĶȡڲĴ
//------------------------------------
void Delay5us();
void Delay5ms();
void MMA8452_Start();
void MMA8452_Stop();
void MMA8452_SendACK(bit ack);
bit  MMA8452_RecvACK();
void MMA8452_SendByte(BYTE dat);
BYTE MMA8452_RecvByte();
void MMA8452_ReadPage();
void MMA8452_WritePage();

uchar  RX_DATA;
//-----------------------------------

void serial_serve(void) interrupt 4	
{  	
	RI=0;
	RX_DATA=SBUF;
}
//*********************************************
//ڳʼ
//9600 bps @ 11.059 MHz 
void init_uart()
{
	TMOD=0x21;				
	TH1=0xfd;				
	TL1=0xfd;				
	SCON=0x50;
	PS=1;      //жΪȼ
	TR0=1;	   //ʱ			
	TR1=1;
	ET0=1;     //򿪶ʱ0ж			
	ES=1;	
	EA=1;
}

//*********ݷ******************
void  SeriPushSend(uchar send_data)
{
    SBUF=send_data;  
	while(!TI);TI=0;	  
}
//*********************************************************
void conversion(uint temp_data)  
{  
    wan=temp_data/10000+0x30 ;
    temp_data=temp_data%10000;   //ȡ
	qian=temp_data/1000+0x30 ;
    temp_data=temp_data%1000;    //ȡ
    bai=temp_data/100+0x30   ;
    temp_data=temp_data%100;     //ȡ
    shi=temp_data/10+0x30    ;
    temp_data=temp_data%10;      //ȡ
    ge=temp_data+0x30; 	
}

/*******************************/
void delay(unsigned int k)	
{						
unsigned int i,j;				
for(i=0;i<k;i++)
{			
for(j=0;j<121;j++)			
{;}}						
}


/**************************************
ʱ5΢(STC90C52RC@12M)
ͬĹ,Ҫ˺עʱӹʱҪ޸
1TMCUʱ,ʱ
**************************************/
void Delay5us()
{
    _nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
}

/**************************************
ʱ5(STC90C52RC@12M)
ͬĹ,Ҫ˺
1TMCUʱ,ʱ
**************************************/
void Delay5ms()
{
    WORD n = 560;

    while (n--);
}

/**************************************
ʼź
**************************************/
void MMA8452_Start()
{
    SDA = 1;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 0;                    //½
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
}

/**************************************
ֹͣź
**************************************/
void MMA8452_Stop()
{
    SDA = 0;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 1;                    //
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
ڲ:ack (0:ACK 1:NAK)
**************************************/
void MMA8452_SendACK(bit ack)
{
    SDA = ack;                  //дӦź
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
**************************************/
bit MMA8452_RecvACK()
{
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    CY = SDA;                   //Ӧź
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ

    return CY;
}

/**************************************
IIC߷һֽ
**************************************/
void MMA8452_SendByte(BYTE dat)
{
    BYTE i;

    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;              //Ƴݵλ
        SDA = CY;               //ݿ
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    MMA8452_RecvACK();
}

/**************************************
IIC߽һֽ
**************************************/
BYTE MMA8452_RecvByte()
{
    BYTE i;
    BYTE dat = 0;

    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        dat |= SDA;             //               
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    return dat;
}

//******ֽд*******************************************

void Single_Write_MMA8452(uchar REG_Address,uchar REG_data)
{
    MMA8452_Start();                  //ʼź
    MMA8452_SendByte(SlaveAddress);   //豸ַ+дź
    MMA8452_SendByte(REG_Address);    //ڲĴַ
    MMA8452_SendByte(REG_data);       //ڲĴ
    MMA8452_Stop();                   //ֹͣź
}

//********ֽڶȡ*****************************************
/*
uchar Single_Read_MMA8452(uchar REG_Address)
{  uchar REG_data;
    MMA8452_Start();                          //ʼź
    MMA8452_SendByte(SlaveAddress);           //豸ַ+дź
    MMA8452_SendByte(REG_Address);                   //ʹ洢Ԫַ0ʼ	
    MMA8452_Start();                          //ʼź
    MMA8452_SendByte(SlaveAddress+1);         //豸ַ+ź
    REG_data=MMA8452_RecvByte();              //Ĵ
	MMA8452_SendACK(1);   
	MMA8452_Stop();                           //ֹͣź
    return REG_data; 
}
*/
//*********************************************************
//
//MMA8452ڲٶݣַΧ0x01~0x06
//
//*********************************************************
void Multiple_read_MMA8452(void)
{   uchar i;
    MMA8452_Start();                          //ʼź
    MMA8452_SendByte(SlaveAddress);           //豸ַ+дź
    MMA8452_SendByte(0x01);                   //ʹ洢Ԫַ0x01ʼ	
    MMA8452_Start();                          //ʼź
    MMA8452_SendByte(SlaveAddress+1);         //豸ַ+ź
	 for (i=0; i<6; i++)                      //ȡ6ַݣ洢BUF
    {
        BUF[i] = MMA8452_RecvByte();          //BUF[0]洢0x32ַе
        if (i == 5)
        {
           MMA8452_SendACK(1);                //һҪNOACK
        }
        else
        {
          MMA8452_SendACK(0);                //ӦACK
       }
   }
    MMA8452_Stop();                          //ֹͣź
    Delay5ms();
}


//*****************************************************************

//ʼMMA8452Ҫοpdf޸************************
void Init_MMA8452()
{
   Single_Write_MMA8452(0x2A,0x01);   //
   Single_Write_MMA8452(0x2B,0x02);   //

}
//***********************************************************************
//ʾx
void display_x()
{   float temp;
    SeriPushSend('X');
    dis_data=(BUF[0]<<8)|BUF[1];  //ϳ   
	dis_data>>=4;
	x=dis_data;
	if(dis_data<0){
  	     dis_data=-dis_data;
	     SeriPushSend('-');
	}
	else SeriPushSend('+');

    temp=(float)dis_data;      //ݺʾ
    conversion(temp);          //תʾҪ

    SeriPushSend(':');
    SeriPushSend(qian);
	SeriPushSend('.');
	SeriPushSend(bai);
	SeriPushSend(shi);
}

//***********************************************************************
//ʾy
void display_y()
{   float temp;
    SeriPushSend('Y');

    dis_data=(BUF[2]<<8)|BUF[3];  //ϳ   
	dis_data>>=4;
	y=dis_data;
	if(dis_data<0){
	dis_data=-dis_data;
    SeriPushSend('-');
	}
	else SeriPushSend('+');

    temp=(float)dis_data;      //ݺʾ
    conversion(temp);          //תʾҪ

	SeriPushSend(':');
	SeriPushSend(qian);
	SeriPushSend('.');
	SeriPushSend(bai);
	SeriPushSend(shi);
}

//***********************************************************************
//ʾz
void display_z()
{   float temp;
    SeriPushSend('Z');
    dis_data=(BUF[4]<<8)|BUF[5];    //ϳ  
    dis_data>>=4;
	z=dis_data;
	if(dis_data<0){
	dis_data=-dis_data;
    SeriPushSend('-');
	}
	else SeriPushSend('+');

    temp=(float)dis_data;      //ݺʾ
    conversion(temp);          //תʾҪ
    
	SeriPushSend(':');
	SeriPushSend(qian);
	SeriPushSend('.');
	SeriPushSend(bai);
	SeriPushSend(shi);
}

//*********************************************************
//**************
//*********************************************************
void main()
{ 
//  uchar devid;
  delay(2);	                   //ϵʱ	
  	
  init_uart();
  Init_MMA8452();                 //ʼMMA8452

  RX_DATA=0;
  while(1)                         //ѭ
  { 
 // if( RX_DATA==0x31){
    Init_MMA8452();                //ʼMMA8452
    Multiple_Read_MMA8452();       //ݣ洢BUF

    SeriPushSend(0x0d);
	SeriPushSend(0x0a);

    display_x();                   //---------ʾX
    display_y();                   //---------ʾY
    display_z();                   //---------ʾZ

	RX_DATA=0;
    delay(50);                    //ʱ50ms      
 //   }
  }
} 
